# Contributing to Dirent

Dirent is an open source project and we love to receive contributions from our
community -- you!  There are many ways to contribute, from writing tutorials
or blog posts, improving the documentation, submitting bug reports and
feature requests, or writing code which can be incorporated into Dirent.

For example, we are looking for contributions which

1. Improve portability of code developed for Unix/Linux to Microsoft Windows.
2. Make Dirent easier to use and/or more useful for programmers working on
   Microsoft Windows platform.
3. Remove compiler warnings or fix bugs.

## How to Suggest a Feature

We use Github to host code, to track issues and to discuss about Dirent.  If
you would like to suggest a feature, then open an issue at Github.

## How to Report a Bug

If you have trouble using Dirent, then try to repeat the problem with the
latest version found at Github.  If the problem remains, then open an issue
at Github.

## How to Submit a Fix or an Enhancement

If you wish to contribute code, then fork the repo and test the change in your
private repo first.  If the change works for you and you would like to donate
the change back to the community, then make a pull request at Github.

Before making a pull request, please consider that:

1. We can only accept contributions which are compatible with [MIT Software
   License](LICENSE).
2. By making a pull request, you agree to transfer all copyrights to us.
3. Our code will be reviewed and edited by us.  In particular, we may
   reformat your code according to the [Linux Kernel Coding
   Style](https://www.kernel.org/doc/html/v4.10/process/coding-style.html)


